SystemOrganization addCategory: #'AdministradorUniversitario-Modelo'!
SystemOrganization addCategory: #'AdministradorUniversitario-UI-Vista'!
SystemOrganization addCategory: #'AdministradorUniversitario-UI-Controlador'!
SystemOrganization addCategory: #'AdministradorUniversitario-Persistencia'!

WAComponent subclass: #Vista
	instanceVariableNames: 'controlador textoError'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AdministradorUniversitario-UI-Vista'!

Vista subclass: #BuscarAlumnoVista
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AdministradorUniversitario-UI-Vista'!

!BuscarAlumnoVista class methodsFor: 'instance creation' stamp: 'PabloAlegre 2/14/2013 00:57'!
canBeRoot 

	^true.! !

!BuscarAlumnoVista class methodsFor: 'instance creation' stamp: 'PabloAlegre 2/14/2013 01:37'!
new

^super new controlador: (BuscarAlumnoControlador new).! !

!BuscarAlumnoVista methodsFor: 'actions' stamp: 'PabloAlegre 2/14/2013 01:47'!
buscarAlumno

	self controlador buscarAlumno.
	textoError:= ''.! !

!BuscarAlumnoVista methodsFor: 'actions' stamp: 'PabloAlegre 2/14/2013 01:48'!
cambiarApellido: unApellido

	self controlador cambiarApellido: unApellido! !

!BuscarAlumnoVista methodsFor: 'actions' stamp: 'PabloAlegre 2/14/2013 01:48'!
cambiarLegajo: unLegajo

	self controlador cambiarLegajo: unLegajo.! !

!BuscarAlumnoVista methodsFor: 'actions' stamp: 'PabloAlegre 2/14/2013 01:48'!
cambiarNombre: unNombre

	self controlador cambiarNombre: unNombre.! !

!BuscarAlumnoVista methodsFor: 'initialization' stamp: 'PabloAlegre 2/14/2013 01:03'!
initialize 

	super initialize.
	self addDecoration: (GroupBoxDecoration new title: 'Buscar Alumno')! !

!BuscarAlumnoVista methodsFor: 'rendering' stamp: 'PabloAlegre 2/14/2013 00:52'!
renderContentOn: html

   html form: [
	self renderFormularioDeBusqueda: html.
	self renderTablaDeAlumnos: html.
	html button callback: [self decoratedComponent answer]; with: 'Volver'
   ].! !

!BuscarAlumnoVista methodsFor: 'rendering' stamp: 'PabloAlegre 2/14/2013 00:52'!
renderFormularioDeBusqueda: html

	html text: 'Legajo: '. html textInput callback: [ : leg | self cambiarLegajo: leg]. html break.
	html text: 'Nombre: '. 
	html textInput callback: [ : nom | self cambiarNombre: nom].html break.
	html text: 'Apellido: '. 
	html textInput callback: [ : ap | self cambiarApellido: ap].
	
	html div 
	  id: 'botones';
	  with:  [
			html button callback: [ self buscarAlumno.]; with: 'Buscar'.
			html button callback: [self restaurarLista.]; with: 'Restaurar Lista'.		
	  ].
	html label: textoError. html break.
! !

!BuscarAlumnoVista methodsFor: 'rendering' stamp: 'PabloAlegre 2/20/2013 21:44'!
renderTablaDeAlumnos: html

html div
   id: 'tablaAlumnos';
   with: [
	html table: [ 
		html tableRow: [ 
			html tableHeading: 'Legajo'.
			html tableHeading: 'Nombre y Apellido'.
			html tableHeading: 'E-Mail'.
			html tableHeading: 'Direccion'.
			html tableHeading.
			html tableHeading.
		].
		(self controlador alumnosEncontrados) do: 
			[ : alumnoEncontrado | html tableRow: [
										html tableData: [ html text: (alumnoEncontrado legajo)].
										html tableData: [ html anchor callback:["self show: (ModificacionAlumno paraAlumno: alumnoEncontrado)"];
																					with: (alumnoEncontrado nombre, ' ', alumnoEncontrado apellido)].
										html tableData: [ html text: (alumnoEncontrado email)].
										html tableData: [ html text: (alumnoEncontrado direccion)].
										html tableData: [ html button callback: [ self show: (InscribirAlumnoVista paraAlumno: alumnoEncontrado)]; with: 'Inscribir'].
										html tableData: [ html button callback: [ self show: (EstadisticasAlumnoVista paraAlumno: alumnoEncontrado)]; with: 'Ver Estadsticas'].		    
								   ]
			]
	].
	]! !

!BuscarAlumnoVista methodsFor: 'actions' stamp: 'PabloAlegre 2/14/2013 01:48'!
restaurarLista 

	self controlador restaurarLista! !

!BuscarAlumnoVista methodsFor: 'rendering' stamp: 'PabloAlegre 2/14/2013 01:09'!
style

^ '
   #botones, #tablaAlumnos{
   	padding-top:25px;
   }
   body{
	border-style:ridge;padding: 5px;
	background-color:#eeeefe;
   }
   table{
  	border-collapse:collapse;
  	background-color:white;
   }
   th{
  	background-color:#ddddff;
   }
   table,th, td {
  	border:1px solid black;
   }
'! !

Vista subclass: #EstadisticasAlumnoVista
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AdministradorUniversitario-UI-Vista'!

!EstadisticasAlumnoVista class methodsFor: 'class initialization' stamp: 'PabloAlegre 2/15/2013 00:16'!
canBeRoot 
^true.! !

!EstadisticasAlumnoVista class methodsFor: 'class initialization' stamp: 'PabloAlegre 2/15/2013 00:26'!
paraAlumno: unAlumno

^super new initializeWith: unAlumno.! !

!EstadisticasAlumnoVista methodsFor: 'actions' stamp: 'PabloAlegre 2/15/2013 00:18'!
alumnoEsAuxiliar
	^self controlador alumnoEsAuxiliar.! !

!EstadisticasAlumnoVista methodsFor: 'actions' stamp: 'PabloAlegre 2/15/2013 00:19'!
apellidoAlumno
	^self controlador apellidoAlumno.! !

!EstadisticasAlumnoVista methodsFor: 'actions' stamp: 'PabloAlegre 2/15/2013 00:19'!
cantidadDeMaterias 
	^self controlador cantidadDeMaterias asString.! !

!EstadisticasAlumnoVista methodsFor: 'actions' stamp: 'PabloAlegre 2/18/2013 16:16'!
carreraActual

	^self controlador carreraActual! !

!EstadisticasAlumnoVista methodsFor: 'actions' stamp: 'PabloAlegre 2/15/2013 00:19'!
carreraActual: seleccionada

	^self controlador carreraActual: seleccionada.! !

!EstadisticasAlumnoVista methodsFor: 'initialization' stamp: 'PabloAlegre 2/15/2013 00:26'!
initializeWith: unAlumno

	super initialize.
	self controlador: (EstadisticasAlumnoControlador paraAlumno: unAlumno).
	self addDecoration: (GroupBoxDecoration  new title: 'Estadisticas del Alumno').! !

!EstadisticasAlumnoVista methodsFor: 'actions' stamp: 'PabloAlegre 2/15/2013 00:19'!
legajoAlumno
	^self controlador legajoAlumno.! !

!EstadisticasAlumnoVista methodsFor: 'actions' stamp: 'PabloAlegre 2/15/2013 00:19'!
materiasActuales
	^self controlador materiasActuales.! !

!EstadisticasAlumnoVista methodsFor: 'actions' stamp: 'PabloAlegre 2/15/2013 00:20'!
materiasAprobadas
	^self controlador materiasAprobadas asString.! !

!EstadisticasAlumnoVista methodsFor: 'actions' stamp: 'PabloAlegre 2/15/2013 00:21'!
materiasCarreraActual
	^self controlador materiasCarreraActual.! !

!EstadisticasAlumnoVista methodsFor: 'actions' stamp: 'PabloAlegre 2/15/2013 00:57'!
materiasCursadasEn: unaCarrera
	^self controlador materiasCursadasEn: unaCarrera.! !

!EstadisticasAlumnoVista methodsFor: 'actions' stamp: 'PabloAlegre 2/15/2013 00:21'!
materiasRecursadas
	^self controlador materiasRecursadas asString.! !

!EstadisticasAlumnoVista methodsFor: 'actions' stamp: 'PabloAlegre 2/15/2013 00:21'!
nombreAlumno
	^self controlador nombreAlumno.! !

!EstadisticasAlumnoVista methodsFor: 'actions' stamp: 'PabloAlegre 2/15/2013 00:22'!
promedioActual
	^self controlador promedioActual asString.! !

!EstadisticasAlumnoVista methodsFor: 'rendering' stamp: 'PabloAlegre 2/15/2013 00:22'!
renderContentOn: html

html form: [
	self renderDatosAlumno: html.
	self renderEstadoAlumno: html.
	self renderEvolucionPorCuatrimestre: html.
	html button callback: [self decoratedComponent answer]; with: 'Volver'
].! !

!EstadisticasAlumnoVista methodsFor: 'rendering' stamp: 'PabloAlegre 2/15/2013 00:22'!
renderDatosAlumno: html

	html div: ('Alumno: ', self nombreAlumno, ' ', self apellidoAlumno).	
	html div: ('Legajo ', (self legajoAlumno)). ! !

!EstadisticasAlumnoVista methodsFor: 'rendering' stamp: 'PabloAlegre 2/15/2013 00:23'!
renderEstadoAlumno: html

	html div 
	  id: 'carreraActual';
	  with: [html text: 'Carrera: '. 
		    (html select)
			list: (HomeCarreras current carreras); beSubmitOnChange;
			callback: [:seleccionada | self carreraActual: seleccionada.]. ].
	
	html div 
	  id: #estadoAlumno; 
	  with: [html text: 'Estado: Activo' ", modelo estadoEn: carreraActual"]. 
		
	html div: 'Materias Aprobadas: ', (self materiasAprobadas), ' de ', self cantidadDeMaterias. 
	html div: 'Materias Recursadas: ', (self materiasRecursadas). 
	html text:  'Materias Actuales: '.
	self renderMateriasActuales: html.
	html div:  'Auxiliar: ',  self alumnoEsAuxiliar.
	html div:  'Promedio: ', self promedioActual.! !

!EstadisticasAlumnoVista methodsFor: 'rendering' stamp: 'PabloAlegre 2/15/2013 00:56'!
renderEvolucionPorCuatrimestre: html
html div
  id:'evolucion';
  with:[
	html table: [
	  html tableRow: [
		html tableHeading: 'Materia'.
		html tableHeading: 'Cuatrimestre'.
		html tableHeading: 'Comision'.
		html tableHeading: 'Resultado'.
		html tableHeading: 'Nota'.
	  ].	
	
	(self materiasCursadasEn: (self carreraActual)) do: 
	  [ :mat | html tableRow: [ html tableData: [html text: (mat nombre)].     
							 html tableData: [html text: (mat cuatrimestre)].
							 html tableData: [html text: (mat comision numero)].
							 html tableData: [html text: (mat estado)].
							 html tableData: [html text: (mat nota )].
	  ]].
	]
  ].! !

!EstadisticasAlumnoVista methodsFor: 'rendering' stamp: 'PabloAlegre 2/15/2013 00:23'!
renderMateriasActuales:html

| materiasEnCurso |
materiasEnCurso:= self materiasActuales.
html select
	size: (materiasEnCurso size max: 2); 
	list: materiasEnCurso.! !

!EstadisticasAlumnoVista methodsFor: 'rendering' stamp: 'PabloAlegre 2/15/2013 00:24'!
style

^ '
   #carreraActual, #estadoAlumno, #evolucion {
	display:block;
   	padding-top:25px;
   }
   body{
	border-style:ridge;
	padding: 5px
   }
   table{
  	border-collapse:collapse;
  	background-color:#ffdddd;
   }
   th{
  	background-color:#ffaaaa;
   }
   table,th, td {
  	border:1px solid black;
   }
'! !

Vista subclass: #InscribirAlumnoVista
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AdministradorUniversitario-UI-Vista'!

!InscribirAlumnoVista class methodsFor: 'class initialization' stamp: 'PabloAlegre 2/20/2013 22:51'!
paraAlumno: unAlumno

	^super new initializeWith: unAlumno.! !

!InscribirAlumnoVista methodsFor: 'as yet unclassified' stamp: 'PabloAlegre 2/20/2013 22:25'!
abrirSeleccionDeComision
	self
		call:
			(SeleccionDeComisionVista deMateria: self materiaActualSeleccionada paraAlumno: (self alumnoAInscribir))
		onAnswer: [ :comisionElegida | 
			self agregarMateriaSeleccionada: comisionElegida.
			self materiasDisponibles remove: self materiaActualSeleccionada ]! !

!InscribirAlumnoVista methodsFor: 'accionesMaterias' stamp: 'PabloAlegre 2/20/2013 21:42'!
agregarMateriaDisponible: unaMateriaDisponible
	self materiasDisponibles add: unaMateriaDisponible.! !

!InscribirAlumnoVista methodsFor: 'accionesMaterias' stamp: 'PabloAlegre 2/20/2013 21:42'!
agregarMateriaSeleccionada: unaMateria

	self materiasSeleccionadas add: unaMateria.! !

!InscribirAlumnoVista methodsFor: 'accionesMaterias' stamp: 'PabloAlegre 2/20/2013 21:37'!
agregarMaterias:materiasSeleccionadas

^self modelo agregarMaterias: materiasSeleccionadas.! !

!InscribirAlumnoVista methodsFor: 'modelo' stamp: 'PabloAlegre 2/20/2013 21:37'!
alumnoAInscribir 
	^self controlador modelo.! !

!InscribirAlumnoVista methodsFor: 'modelo' stamp: 'PabloAlegre 2/20/2013 21:38'!
apellidoAlumnoAInscribir 
	^self alumnoAInscribir apellido.! !

!InscribirAlumnoVista methodsFor: 'as yet unclassified' stamp: 'PabloAlegre 2/20/2013 22:52'!
initializeWith: unAlumno

	super initialize.
	self controlador: (InscribirAlumnoControlador paraAlumno: unAlumno).
	self addDecoration: (GroupBoxDecoration  new title: 'Inscripcin de Alumno').! !

!InscribirAlumnoVista methodsFor: 'modelo' stamp: 'PabloAlegre 2/20/2013 21:38'!
legajoAlumnoAInscribir 
	^self alumnoAInscribir legajo.! !

!InscribirAlumnoVista methodsFor: 'accionesMaterias' stamp: 'PabloAlegre 2/20/2013 21:58'!
materiaAEliminar

	^self controlador materiaAEliminar! !

!InscribirAlumnoVista methodsFor: 'accionesMaterias' stamp: 'PabloAlegre 2/20/2013 22:00'!
materiaAEliminar: unaMateria

	^self controlador materiaAEliminar: unaMateria ! !

!InscribirAlumnoVista methodsFor: 'accionesMaterias' stamp: 'PabloAlegre 2/20/2013 21:59'!
materiaActualSeleccionada

	^self controlador materiaActualSeleccionada ! !

!InscribirAlumnoVista methodsFor: 'accionesMaterias' stamp: 'PabloAlegre 2/20/2013 22:00'!
materiaActualSeleccionada: unaMateria

	^self controlador materiaActualSeleccionada: unaMateria ! !

!InscribirAlumnoVista methodsFor: 'accionesMaterias' stamp: 'PabloAlegre 2/20/2013 21:56'!
materiasDisponibles
	^self controlador materiasDisponibles.! !

!InscribirAlumnoVista methodsFor: 'accionesMaterias' stamp: 'PabloAlegre 2/20/2013 21:56'!
materiasDisponiblesParaUnAlumno 
	^self controlador materiasDisponiblesParaUnAlumno.! !

!InscribirAlumnoVista methodsFor: 'accionesMaterias' stamp: 'PabloAlegre 2/20/2013 21:57'!
materiasSeleccionadas 

	^self controlador materiasSeleccionadas.! !

!InscribirAlumnoVista methodsFor: 'modelo' stamp: 'PabloAlegre 2/20/2013 21:39'!
nombreAlumnoAInscribir 
	^self alumnoAInscribir nombre.! !

!InscribirAlumnoVista methodsFor: 'rendering' stamp: 'PabloAlegre 2/20/2013 21:37'!
renderBotonesParaInscribirAlumno: html

html div 
	  id: 'botones';
	  with: [
		(html button) callback: [ [ self agregarMaterias: self materiasSeleccionadas. self modelo save. self modelo back]]; with: 'Confirmar'.
		(html button) callback: [ self modelo back ]; with: 'Cancelar'.
	  ].! !

!InscribirAlumnoVista methodsFor: 'rendering' stamp: 'PabloAlegre 2/18/2013 16:44'!
renderContentOn: html

	self renderDatosBasicosAlumno: html.
	html form: [
		self renderMaterias: html.
		self renderBotonesParaInscribirAlumno: html.
		html button callback: [self decoratedComponent answer]; with: 'Volver'
		]! !

!InscribirAlumnoVista methodsFor: 'rendering' stamp: 'PabloAlegre 2/20/2013 21:55'!
renderDatosBasicosAlumno: html

	html div: 'Alumno: ', self nombreAlumnoAInscribir, ' ', self apellidoAlumnoAInscribir.
	html div: 'Legajo: ', self legajoAlumnoAInscribir asString.
! !

!InscribirAlumnoVista methodsFor: 'rendering' stamp: 'PabloAlegre 2/20/2013 22:32'!
renderMaterias:html

html select
	size: self materiasDisponibles size; 
	list: self materiasSeleccionadas; beSubmitOnChange;
	selected: self materiaAEliminar;
	callback:  [:value | 
		self materiaAEliminar: value.
	].
(html anchor) callback: [ self sacarMateria];with: 'sacarMateria' .
(html popupAnchor) extent: 400 @ 400; position: 50 @ 50; callback: [self abrirSeleccionDeComision]; with: 'AgregarMateria' .

html select
	size: self materiasDisponibles size; 
	list: self materiasDisponibles; beSubmitOnChange;
	selected: self materiaActualSeleccionada; 
	callback: [:value | 
		self materiaActualSeleccionada: value
	].
! !

!InscribirAlumnoVista methodsFor: 'accionesMaterias' stamp: 'PabloAlegre 2/20/2013 21:43'!
sacarMateria

self agregarMateriaDisponible: (self materiaAEliminar comision materia).
self materiasSeleccionadas remove: self materiaAEliminar.! !

Vista subclass: #SeleccionDeComisionVista
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AdministradorUniversitario-UI-Vista'!

!SeleccionDeComisionVista class methodsFor: 'as yet unclassified' stamp: 'PabloAlegre 2/20/2013 22:30'!
deMateria: unaMateria paraAlumno: unAlumno

	^super new initializeWith: unaMateria and:  unAlumno! !

!SeleccionDeComisionVista methodsFor: 'accessing' stamp: 'PabloAlegre 2/20/2013 22:15'!
alumnoAInscribir
	^ self controlador modelo! !

!SeleccionDeComisionVista methodsFor: 'accessing' stamp: 'PabloAlegre 2/20/2013 22:15'!
alumnoAInscribir: anObject
	self controlador modelo: anObject! !

!SeleccionDeComisionVista methodsFor: 'as yet unclassified' stamp: 'PabloAlegre 2/20/2013 22:29'!
initializeWith: unAlumno

	super initialize.
	self controlador: (EstadisticasAlumnoControlador paraAlumno: unAlumno).
	self addDecoration: (GroupBoxDecoration  new title: 'Estadisticas del Alumno').! !

!SeleccionDeComisionVista methodsFor: 'as yet unclassified' stamp: 'PabloAlegre 2/20/2013 22:30'!
initializeWith: unaMateria and: unAlumno

	super initialize.
	self controlador: (SeleccionDeComisionControlador deMateria: unaMateria paraAlumno: unAlumno).
	self addDecoration: (GroupBoxDecoration  new title: 'Seleccion de Comision').! !

!SeleccionDeComisionVista methodsFor: 'accessing' stamp: 'PabloAlegre 2/20/2013 22:14'!
materia
	^ self controlador materia! !

!SeleccionDeComisionVista methodsFor: 'accessing' stamp: 'PabloAlegre 2/20/2013 22:16'!
materia: anObject
	self controlador materia: anObject! !

!SeleccionDeComisionVista methodsFor: 'rendering' stamp: 'PabloAlegre 2/20/2013 22:48'!
renderContentOn: html

html form: [

	self renderListaDeComisionesDisponibles: html.
	
]
! !

!SeleccionDeComisionVista methodsFor: 'rendering' stamp: 'PabloAlegre 2/20/2013 22:49'!
renderListaDeComisionesDisponibles: html 

| radioGroupDeComisiones |

html heading: 'Seleccione una comisin'.

radioGroupDeComisiones := html radioGroup.

HomeComisiones current comisiones do: [ : comision | 
	radioGroupDeComisiones radioButton 
		callback: [ ].
        	html text: (comision asString).
		html break.
	]
! !

!Vista methodsFor: 'as yet unclassified' stamp: 'PabloAlegre 2/18/2013 16:45'!
back

	self controlador back.! !

!Vista methodsFor: 'accessing' stamp: 'PabloAlegre 2/14/2013 01:36'!
controlador
	^ controlador! !

!Vista methodsFor: 'accessing' stamp: 'PabloAlegre 2/14/2013 01:36'!
controlador: anObject
	controlador := anObject! !

!Vista methodsFor: 'rendering' stamp: 'PabloAlegre 2/14/2013 00:52'!
renderContentOn: html

	self subclassResponsibility! !

!Vista methodsFor: 'as yet unclassified' stamp: 'PabloAlegre 2/18/2013 16:45'!
save

	self controlador save.! !

WAWindowDecoration subclass: #GroupBoxDecoration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AdministradorUniversitario-UI-Vista'!

!GroupBoxDecoration methodsFor: 'rendering' stamp: 'PabloAlegre 2/14/2013 01:01'!
renderCloseButtonOn: html

	"No button"! !

!GroupBoxDecoration methodsFor: 'rendering' stamp: 'PabloAlegre 2/14/2013 01:05'!
style

^ '.window-titlebar {background-color: #ccccff; padding: 5px; margin-bottom: 5px}
	    .window-close {float: right}
	   .window-title {}
	    .window-content {clear: both}
	'! !

Object subclass: #Alumno
	instanceVariableNames: 'nombre apellido dni direccion telefono legajo email esAuxiliar materiasActuales materiasCursadas'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AdministradorUniversitario-Modelo'!

!Alumno class methodsFor: 'class initialization' stamp: 'PabloAlegre 2/15/2013 01:00'!
conMateriasCursadas
 | alumno cursoIntro cursoObj1 cursoOrga cursoMate1|
 alumno:= Alumno conNombre: 'Pablo' conApellido: 'Alegre' conDNI: 35000000 conDireccion: 'Florencio Varela' conEmail: 'pablo@gmail.com'  yLegajo: 20000.
cursoIntro:= MateriaCursada enComision: (Comision numero: 1 delCuatrimestre: '2008-c1' deLaMateria: (HomeMaterias current  get: 'InPr')).
cursoObj1:= MateriaCursada enComision: (Comision numero: 3 delCuatrimestre: '2008-c1' deLaMateria:  (HomeMaterias current  get: 'Orga')).
cursoOrga:= MateriaCursada enComision: (Comision numero: 2 delCuatrimestre: '2008-c2' deLaMateria:  (HomeMaterias current  get: 'Mate1')).
cursoMate1:= MateriaCursada enComision: (Comision numero: 1 delCuatrimestre: '2008-c2' deLaMateria:  (HomeMaterias current  get: 'Obj1')).
cursoIntro estado: 'Aprobado'; nota: 8.
cursoIntro comision materia carreras add: (HomeCarreras current get: 'TPI').
cursoObj1 estado: 'En curso'; nota: 7.
cursoObj1 comision materia carreras add: (HomeCarreras current get: 'TPI').
cursoOrga estado: 'Pendiente'; nota: 5.
cursoOrga comision materia carreras add: (HomeCarreras current get: 'TPI').
cursoMate1 estado: 'Recursado'; nota: 3.
cursoMate1 comision materia carreras add: (HomeCarreras current get: 'TPI').
 alumno materiasCursadas add: cursoIntro.
 alumno materiasCursadas add: cursoObj1.
 alumno materiasCursadas add: cursoOrga.
 alumno materiasCursadas add: cursoMate1.
 ^alumno.! !

!Alumno class methodsFor: 'class initialization' stamp: 'PabloAlegre 2/15/2013 01:04'!
conNombre: unNombre conApellido: unApellido conDNI: unDNI conDireccion: unaDireccion conEmail: unEmail yLegajo: unLegajo
	^ super new
		materiasActuales: OrderedCollection new;
		materiasCursadas: OrderedCollection new;
		nombre: unNombre;
		apellido: unApellido;
		dni: unDNI;
		direccion: unaDireccion;
		email: unEmail;
		legajo: unLegajo;
		esAuxiliar: false.! !

!Alumno methodsFor: 'accessing' stamp: 'PabloAlegre 2/13/2013 21:59'!
apellido
	^ apellido! !

!Alumno methodsFor: 'accessing' stamp: 'PabloAlegre 2/13/2013 21:59'!
apellido: anObject
	apellido := anObject! !

!Alumno methodsFor: 'estadisticas' stamp: 'PabloAlegre 2/15/2013 01:09'!
cantidadDeMateriasEn: unaCarrera conEstado: unEstado
 
	| cantidadDeMaterias |
	cantidadDeMaterias := 0.	
	self materiasCursadas do: [ : materiaCursada | ((materiaCursada carreras includes: unaCarrera) and: (materiaCursada estado = unEstado)) ifTrue: [cantidadDeMaterias := cantidadDeMaterias + 1]].
	^cantidadDeMaterias.! !

!Alumno methodsFor: 'accessing' stamp: 'PabloAlegre 2/13/2013 21:59'!
direccion
	^ direccion! !

!Alumno methodsFor: 'accessing' stamp: 'PabloAlegre 2/13/2013 21:59'!
direccion: anObject
	direccion := anObject! !

!Alumno methodsFor: 'accessing' stamp: 'PabloAlegre 2/13/2013 21:59'!
dni
	^ dni! !

!Alumno methodsFor: 'accessing' stamp: 'PabloAlegre 2/13/2013 21:59'!
dni: anObject
	dni := anObject! !

!Alumno methodsFor: 'accessing' stamp: 'PabloAlegre 2/13/2013 21:59'!
email
	^ email! !

!Alumno methodsFor: 'accessing' stamp: 'PabloAlegre 2/13/2013 21:59'!
email: anObject
	email := anObject! !

!Alumno methodsFor: 'accessing' stamp: 'PabloAlegre 2/13/2013 21:59'!
esAuxiliar
	^ esAuxiliar! !

!Alumno methodsFor: 'accessing' stamp: 'PabloAlegre 2/13/2013 21:59'!
esAuxiliar: anObject
	esAuxiliar := anObject! !

!Alumno methodsFor: 'accessing' stamp: 'PabloAlegre 2/13/2013 21:59'!
legajo
	^ legajo! !

!Alumno methodsFor: 'accessing' stamp: 'PabloAlegre 2/13/2013 21:59'!
legajo: anObject
	legajo := anObject! !

!Alumno methodsFor: 'estadisticas' stamp: 'PabloAlegre 2/15/2013 00:36'!
listaDeMateriasEn: unaCarrera conEstado: unEstado
 	^self materiasCursadas select: [ :materiaCursada | (materiaCursada contieneCarrera: unaCarrera) and: (materiaCursada estado = unEstado)].! !

!Alumno methodsFor: 'accessing' stamp: 'PabloAlegre 2/13/2013 22:01'!
materiasActuales
	^ materiasActuales! !

!Alumno methodsFor: 'accessing' stamp: 'PabloAlegre 2/15/2013 01:08'!
materiasActuales: anObject

	materiasActuales := anObject ! !

!Alumno methodsFor: 'estadisticas' stamp: 'PabloAlegre 2/15/2013 01:06'!
materiasActualesEn: unaCarrera

	^self materiasActuales select: [ :materiaActual | (materiaActual contieneCarrera: unaCarrera) and: (materiaActual estado = 'En Curso')].! !

!Alumno methodsFor: 'estadisticas' stamp: 'PabloAlegre 2/15/2013 00:31'!
materiasAprobadas: unaCarrera
 
	^self cantidadDeMateriasEn: unaCarrera conEstado: 'Aprobado'! !

!Alumno methodsFor: 'accessing' stamp: 'PabloAlegre 2/13/2013 21:59'!
materiasCursadas
	^ materiasCursadas! !

!Alumno methodsFor: 'accessing' stamp: 'PabloAlegre 2/13/2013 21:59'!
materiasCursadas: anObject
	materiasCursadas := anObject! !

!Alumno methodsFor: 'estadisticas' stamp: 'PabloAlegre 2/15/2013 01:08'!
materiasCursadasEn: unaCarrera

	| materiasEsteCuatri |
	materiasEsteCuatri:= self materiasActuales.
	^self materiasCursadas select: [ :materiaCursada | (materiasEsteCuatri includes: materiaCursada) = false].! !

!Alumno methodsFor: 'estadisticas' stamp: 'PabloAlegre 2/15/2013 00:41'!
materiasRecursadas: unaCarrera
 
	 ^self cantidadDeMateriasEn: unaCarrera conEstado: 'Recursado'! !

!Alumno methodsFor: 'accessing' stamp: 'PabloAlegre 2/13/2013 21:59'!
nombre
	^ nombre! !

!Alumno methodsFor: 'accessing' stamp: 'PabloAlegre 2/13/2013 21:59'!
nombre: anObject
	nombre := anObject! !

!Alumno methodsFor: 'printing' stamp: 'PabloAlegre 2/13/2013 22:49'!
printOn: aStream

    aStream nextPutAll: (self nombre,' ',self apellido).! !

!Alumno methodsFor: 'estadisticas' stamp: 'PabloAlegre 2/15/2013 00:42'!
promedioActual
 
	| notas |
	notas:= (self materiasCursadas collect: [ :materiaCursada | (materiaCursada nota)]).
	notas:= notas fold: [ :nota1 :nota2 | nota1 + nota2].
 	^notas / (materiasCursadas size) asFloat.! !

!Alumno methodsFor: 'estadisticas' stamp: 'PabloAlegre 2/15/2013 00:45'!
promedioActualEn: unaCarrera
	| materias notas |
	materias := self materiasCursadasEn: unaCarrera.
	notas := materias collect: [ :materiaCursada | materiaCursada nota ].
	notas isEmpty
		ifTrue: [ ^ 0 ]
		ifFalse: [ 
			notas := notas fold: [ :nota1 :nota2 | nota1 + nota2 ].
			^ notas / materias size asFloat ]! !

!Alumno methodsFor: 'accessing' stamp: 'PabloAlegre 2/13/2013 21:59'!
telefono
	^ telefono! !

!Alumno methodsFor: 'accessing' stamp: 'PabloAlegre 2/13/2013 21:59'!
telefono: anObject
	telefono := anObject! !

Object subclass: #Carrera
	instanceVariableNames: 'nombre materias'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AdministradorUniversitario-Modelo'!

!Carrera class methodsFor: 'class initialization' stamp: 'PabloAlegre 2/13/2013 22:42'!
llamada: unNombre
	^ super new
		nombre: unNombre;
		materias: OrderedCollection new! !

!Carrera methodsFor: 'accessing' stamp: 'PabloAlegre 2/13/2013 22:04'!
materias
	^ materias! !

!Carrera methodsFor: 'accessing' stamp: 'PabloAlegre 2/13/2013 22:04'!
materias: anObject
	materias := anObject! !

!Carrera methodsFor: 'actions' stamp: 'PabloAlegre 2/20/2013 21:53'!
materiasDisponiblesPara: unAlumno
 	|materiasCursadasAprobadas materiasAlumno materiasNoCursadas |
	materiasCursadasAprobadas:= (unAlumno materiasCursadas select: [ : materiaCursada | (materiaCursada contieneCarrera: self) and: ((materiaCursada estado  = 'Aprobado') or: (materiaCursada estado  = 'En curso'))]). 
	materiasAlumno:= (materiasCursadasAprobadas collect: [ : materiaCursada | materiaCursada comision materia]).
	materiasNoCursadas:= self materias select: [ :materia | ( materiasAlumno includes: materia) not].
	^materiasNoCursadas select: [ :materia | (materiasAlumno includesAllOf: (materia correlativas))].! !

!Carrera methodsFor: 'accessing' stamp: 'PabloAlegre 2/13/2013 22:04'!
nombre
	^ nombre! !

!Carrera methodsFor: 'accessing' stamp: 'PabloAlegre 2/13/2013 22:04'!
nombre: anObject
	nombre := anObject! !

!Carrera methodsFor: 'printing' stamp: 'PabloAlegre 2/13/2013 22:50'!
printOn: aStream

    aStream nextPutAll: (self nombre).! !

Object subclass: #Comision
	instanceVariableNames: 'numero cuatrimestre materia horarios docenteTitular docenteSecundario alumnos'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AdministradorUniversitario-Modelo'!

!Comision class methodsFor: 'class initialization' stamp: 'PabloAlegre 2/13/2013 23:06'!
numero: numeroDeComision delCuatrimestre: anioYNumeroDeCuatrimestre deLaMateria: unaMateria
	^ super new
		numero: numeroDeComision;
		cuatrimestre: anioYNumeroDeCuatrimestre;
		materia: unaMateria;
		horarios: OrderedCollection new;
		alumnos: OrderedCollection new.! !

!Comision methodsFor: 'accessing' stamp: 'PabloAlegre 2/13/2013 22:58'!
alumnos
	^ alumnos! !

!Comision methodsFor: 'accessing' stamp: 'PabloAlegre 2/13/2013 22:59'!
alumnos: anObject
	alumnos := anObject! !

!Comision methodsFor: 'accessing' stamp: 'PabloAlegre 2/13/2013 22:07'!
cuatrimestre
	^ cuatrimestre! !

!Comision methodsFor: 'accessing' stamp: 'PabloAlegre 2/13/2013 22:07'!
cuatrimestre: anObject
	cuatrimestre := anObject! !

!Comision methodsFor: 'accessing' stamp: 'PabloAlegre 2/13/2013 22:07'!
docenteSecundario
	^ docenteSecundario! !

!Comision methodsFor: 'accessing' stamp: 'PabloAlegre 2/13/2013 22:07'!
docenteSecundario: anObject
	docenteSecundario := anObject! !

!Comision methodsFor: 'accessing' stamp: 'PabloAlegre 2/13/2013 22:07'!
docenteTitular
	^ docenteTitular! !

!Comision methodsFor: 'accessing' stamp: 'PabloAlegre 2/13/2013 22:07'!
docenteTitular: anObject
	docenteTitular := anObject! !

!Comision methodsFor: 'accessing' stamp: 'PabloAlegre 2/13/2013 22:07'!
horarios
	^ horarios! !

!Comision methodsFor: 'accessing' stamp: 'PabloAlegre 2/13/2013 22:07'!
horarios: anObject
	horarios := anObject! !

!Comision methodsFor: 'accessing' stamp: 'PabloAlegre 2/13/2013 22:07'!
materia
	^ materia! !

!Comision methodsFor: 'accessing' stamp: 'PabloAlegre 2/13/2013 22:07'!
materia: anObject
	materia := anObject! !

!Comision methodsFor: 'accessing' stamp: 'PabloAlegre 2/13/2013 22:07'!
numero
	^ numero! !

!Comision methodsFor: 'accessing' stamp: 'PabloAlegre 2/13/2013 22:07'!
numero: anObject
	numero := anObject! !

!Comision methodsFor: 'printing' stamp: 'PabloAlegre 2/13/2013 22:50'!
printOn: aStream

    aStream nextPutAll: (self materia asString,'-',self cuatrimestre asString,'-',self numero asString).
! !

Object subclass: #Controlador
	instanceVariableNames: 'modelo modeloOriginal'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AdministradorUniversitario-UI-Controlador'!

Controlador subclass: #BuscarAlumnoControlador
	instanceVariableNames: 'alumnosDelSistema alumnosEncontrados'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AdministradorUniversitario-UI-Controlador'!

!BuscarAlumnoControlador methodsFor: 'accessing' stamp: 'PabloAlegre 2/14/2013 00:44'!
alumnosDelSistema
	^ alumnosDelSistema! !

!BuscarAlumnoControlador methodsFor: 'accessing' stamp: 'PabloAlegre 2/14/2013 00:44'!
alumnosDelSistema: anObject
	alumnosDelSistema := anObject! !

!BuscarAlumnoControlador methodsFor: 'accessing' stamp: 'PabloAlegre 2/14/2013 00:44'!
alumnosEncontrados
	^ alumnosEncontrados! !

!BuscarAlumnoControlador methodsFor: 'accessing' stamp: 'PabloAlegre 2/14/2013 00:44'!
alumnosEncontrados: anObject
	alumnosEncontrados := anObject! !

!BuscarAlumnoControlador methodsFor: 'actions' stamp: 'PabloAlegre 2/14/2013 02:06'!
buscarAlumno 

	self alumnosEncontrados: (self alumnosDelSistema).

	(self modelo legajo isNil ) ifFalse: [self alumnosEncontrados: (self alumnosDelSistema select: [ : alumno | (alumno legajo asString beginsWith: self modelo legajo asString)]) asSet].
	(self modelo nombre = '') ifFalse: [self alumnosEncontrados: (self alumnosEncontrados select: [ : alumno | (alumno nombre asLowercase beginsWith:  self modelo nombre asLowercase)])].
	(self modelo apellido = '') ifFalse: [self alumnosEncontrados: (self alumnosEncontrados select: [ : alumno | (alumno apellido asLowercase beginsWith:  self modelo apellido asLowercase)])].! !

!BuscarAlumnoControlador methodsFor: 'actions' stamp: 'PabloAlegre 2/14/2013 01:49'!
cambiarApellido: nuevoApellido

	self modelo apellido: nuevoApellido! !

!BuscarAlumnoControlador methodsFor: 'actions' stamp: 'PabloAlegre 2/14/2013 01:46'!
cambiarLegajo: nuevoLegajo 

	self modelo legajo: (nuevoLegajo asInteger).! !

!BuscarAlumnoControlador methodsFor: 'actions' stamp: 'PabloAlegre 2/14/2013 01:46'!
cambiarNombre: nuevoNombre 

	self modelo nombre: nuevoNombre.! !

!BuscarAlumnoControlador methodsFor: 'initializing' stamp: 'PabloAlegre 2/14/2013 01:41'!
initialize 

	self modelo: (Alumno new nombre: ''; apellido: ''; legajo: 0); 
		alumnosDelSistema: (HomeAlumnos current listAll);
	 	alumnosEncontrados:  (self alumnosDelSistema).! !

!BuscarAlumnoControlador methodsFor: 'actions' stamp: 'PabloAlegre 2/14/2013 00:49'!
restaurarLista

	self alumnosEncontrados: (self alumnosDelSistema).! !

!Controlador methodsFor: 'as yet unclassified' stamp: 'PabloAlegre 2/18/2013 16:39'!
back
	self decoratedComponent answer.! !

!Controlador methodsFor: 'accessing' stamp: 'PabloAlegre 2/14/2013 00:44'!
modelo
	^ modelo! !

!Controlador methodsFor: 'accessing' stamp: 'PabloAlegre 2/14/2013 00:44'!
modelo: anObject
	modelo := anObject! !

!Controlador methodsFor: 'accessing' stamp: 'PabloAlegre 2/14/2013 01:41'!
modeloOriginal
	^ modeloOriginal! !

!Controlador methodsFor: 'accessing' stamp: 'PabloAlegre 2/14/2013 01:41'!
modeloOriginal: anObject
	modeloOriginal := anObject! !

!Controlador methodsFor: 'as yet unclassified' stamp: 'PabloAlegre 2/18/2013 16:40'!
save
	modeloOriginal become: modelo.! !

Controlador subclass: #EstadisticasAlumnoControlador
	instanceVariableNames: 'carreraActual'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AdministradorUniversitario-UI-Controlador'!

!EstadisticasAlumnoControlador class methodsFor: 'class initialization' stamp: 'PabloAlegre 2/15/2013 00:08'!
paraAlumno: unAlumno

	^super new initializeWith: unAlumno.! !

!EstadisticasAlumnoControlador methodsFor: 'actionsAlumno' stamp: 'PabloAlegre 2/15/2013 00:11'!
alumnoEsAuxiliar 

(self modelo esAuxiliar) 
   ifTrue: [^'Si'] 
   ifFalse: [^'No']. ! !

!EstadisticasAlumnoControlador methodsFor: 'actionsAlumno' stamp: 'PabloAlegre 2/15/2013 00:11'!
apellidoAlumno
	^self modelo apellido.! !

!EstadisticasAlumnoControlador methodsFor: 'actionsCarrera' stamp: 'PabloAlegre 2/15/2013 00:13'!
cantidadDeMaterias
	^self carreraActual materias size.! !

!EstadisticasAlumnoControlador methodsFor: 'accessing' stamp: 'PabloAlegre 2/15/2013 00:07'!
carreraActual
	^ carreraActual! !

!EstadisticasAlumnoControlador methodsFor: 'accessing' stamp: 'PabloAlegre 2/15/2013 00:07'!
carreraActual: anObject
	carreraActual := anObject! !

!EstadisticasAlumnoControlador methodsFor: 'actionsMateria' stamp: 'PabloAlegre 2/15/2013 00:13'!
comisionMateria: unaMateria
 ^unaMateria comision numero.! !

!EstadisticasAlumnoControlador methodsFor: 'actionsMateria' stamp: 'PabloAlegre 2/15/2013 00:13'!
cuatrimestreMateria: unaMateria
 ^unaMateria cuatrimestre.! !

!EstadisticasAlumnoControlador methodsFor: 'actionsAlumno' stamp: 'PabloAlegre 2/15/2013 00:11'!
estadoActualDeAlumnoEnCarrera
	^ self modelo estadoEn: self carreraActual.! !

!EstadisticasAlumnoControlador methodsFor: 'actionsMateria' stamp: 'PabloAlegre 2/15/2013 00:14'!
estadoMateria: unaMateria
 ^unaMateria estado.! !

!EstadisticasAlumnoControlador methodsFor: 'intializing' stamp: 'PabloAlegre 2/15/2013 00:35'!
initializeWith: unAlumno

	self modelo: unAlumno.
	self carreraActual: (HomeCarreras current carreras at: 1).! !

!EstadisticasAlumnoControlador methodsFor: 'actionsAlumno' stamp: 'PabloAlegre 2/15/2013 00:11'!
legajoAlumno
	^self modelo legajo asString.! !

!EstadisticasAlumnoControlador methodsFor: 'actionsAlumno' stamp: 'PabloAlegre 2/15/2013 01:06'!
materiasActuales
	^ self modelo materiasActualesEn: (self carreraActual).! !

!EstadisticasAlumnoControlador methodsFor: 'actionsAlumno' stamp: 'PabloAlegre 2/15/2013 00:12'!
materiasAprobadas
	^ (self modelo materiasAprobadas: (self carreraActual)) asString.! !

!EstadisticasAlumnoControlador methodsFor: 'actionsAlumno' stamp: 'PabloAlegre 2/18/2013 16:06'!
materiasCursadasEn: unaCarrera

	^self modelo materiasCursadas select: [ :materiaCursada | materiaCursada perteneceACarrera: unaCarrera].! !

!EstadisticasAlumnoControlador methodsFor: 'actionsAlumno' stamp: 'PabloAlegre 2/15/2013 00:12'!
materiasRecursadas
	^ (self modelo materiasRecursadas: (self carreraActual)) asString.! !

!EstadisticasAlumnoControlador methodsFor: 'actionsAlumno' stamp: 'PabloAlegre 2/15/2013 00:12'!
nombreAlumno
	^self modelo nombre.! !

!EstadisticasAlumnoControlador methodsFor: 'actionsMateria' stamp: 'PabloAlegre 2/15/2013 00:14'!
nombreMateria: unaMateria
 ^unaMateria nombre.! !

!EstadisticasAlumnoControlador methodsFor: 'actionsMateria' stamp: 'PabloAlegre 2/15/2013 00:14'!
notaFinalMateria: unaMateria
 ^unaMateria nota.! !

!EstadisticasAlumnoControlador methodsFor: 'actionsAlumno' stamp: 'PabloAlegre 2/15/2013 00:44'!
promedioActual
	^(self modelo promedioActualEn: (self carreraActual)) asString.! !

Controlador subclass: #InscribirAlumnoControlador
	instanceVariableNames: 'carrera materiasDisponibles materiasSeleccionadas materiaActualSeleccionada materiaAEliminar'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AdministradorUniversitario-UI-Controlador'!

!InscribirAlumnoControlador class methodsFor: 'class initialization' stamp: 'PabloAlegre 2/20/2013 21:46'!
paraAlumno: unAlumno

	 ^super new initializeWith: unAlumno.! !

!InscribirAlumnoControlador methodsFor: 'accessing' stamp: 'PabloAlegre 2/20/2013 21:53'!
carrera
	^ carrera! !

!InscribirAlumnoControlador methodsFor: 'accessing' stamp: 'PabloAlegre 2/20/2013 21:53'!
carrera: anObject
	carrera := anObject! !

!InscribirAlumnoControlador methodsFor: 'initialization' stamp: 'PabloAlegre 2/20/2013 21:47'!
initializeWith: unAlumno

	self modelo: unAlumno.
	self carrera: (HomeCarreras current get: 'TPI').
	self materiasSeleccionadas: (self modelo materiasActuales).
	self materiasDisponibles: (self materiasDisponiblesParaUnAlumno).! !

!InscribirAlumnoControlador methodsFor: 'accessing' stamp: 'PabloAlegre 2/20/2013 21:53'!
materiaAEliminar
	^ materiaAEliminar! !

!InscribirAlumnoControlador methodsFor: 'accessing' stamp: 'PabloAlegre 2/20/2013 21:53'!
materiaAEliminar: anObject
	materiaAEliminar := anObject! !

!InscribirAlumnoControlador methodsFor: 'accessing' stamp: 'PabloAlegre 2/20/2013 21:53'!
materiaActualSeleccionada
	^ materiaActualSeleccionada! !

!InscribirAlumnoControlador methodsFor: 'accessing' stamp: 'PabloAlegre 2/20/2013 21:53'!
materiaActualSeleccionada: anObject
	materiaActualSeleccionada := anObject! !

!InscribirAlumnoControlador methodsFor: 'accessing' stamp: 'PabloAlegre 2/20/2013 21:53'!
materiasDisponibles
	^ materiasDisponibles! !

!InscribirAlumnoControlador methodsFor: 'accessing' stamp: 'PabloAlegre 2/20/2013 21:53'!
materiasDisponibles: anObject
	materiasDisponibles := anObject! !

!InscribirAlumnoControlador methodsFor: 'actions' stamp: 'PabloAlegre 2/18/2013 16:40'!
materiasDisponiblesParaUnAlumno
	^ self carrera materiasDisponiblesPara: (self modelo).! !

!InscribirAlumnoControlador methodsFor: 'accessing' stamp: 'PabloAlegre 2/20/2013 21:53'!
materiasSeleccionadas
	^ materiasSeleccionadas! !

!InscribirAlumnoControlador methodsFor: 'accessing' stamp: 'PabloAlegre 2/20/2013 21:53'!
materiasSeleccionadas: anObject
	materiasSeleccionadas := anObject! !

Controlador subclass: #SeleccionDeComisionControlador
	instanceVariableNames: 'materia alumnoAInscribir'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AdministradorUniversitario-UI-Controlador'!

!SeleccionDeComisionControlador class methodsFor: 'as yet unclassified' stamp: 'PabloAlegre 2/20/2013 22:28'!
deMateria: unaMateria paraAlumno: unAlumno

	^super new materia: unaMateria; modelo: unAlumno! !

!SeleccionDeComisionControlador methodsFor: 'accessing' stamp: 'PabloAlegre 2/20/2013 22:31'!
alumnoAInscribir
	^ alumnoAInscribir! !

!SeleccionDeComisionControlador methodsFor: 'accessing' stamp: 'PabloAlegre 2/20/2013 22:31'!
alumnoAInscribir: anObject
	alumnoAInscribir := anObject! !

!SeleccionDeComisionControlador methodsFor: 'accessing' stamp: 'PabloAlegre 2/20/2013 22:31'!
materia
	^ materia! !

!SeleccionDeComisionControlador methodsFor: 'accessing' stamp: 'PabloAlegre 2/20/2013 22:31'!
materia: anObject
	materia := anObject! !

Object subclass: #HomeAlumnos
	instanceVariableNames: 'alumnos'
	classVariableNames: 'instance'
	poolDictionaries: ''
	category: 'AdministradorUniversitario-Persistencia'!

!HomeAlumnos class methodsFor: 'accessing' stamp: 'PabloAlegre 2/20/2013 22:50'!
current
	"instance:= nil."
	(instance isNil) ifTrue: [instance:= super new.].
	^instance.! !

!HomeAlumnos methodsFor: 'accessing' stamp: 'PabloAlegre 2/14/2013 00:03'!
alumnos
	^ alumnos! !

!HomeAlumnos methodsFor: 'accessing' stamp: 'PabloAlegre 2/14/2013 00:03'!
alumnos: anObject
	alumnos := anObject! !

!HomeAlumnos methodsFor: 'accessing' stamp: 'PabloAlegre 2/14/2013 00:20'!
get: numeroDeLegajo

	^(self alumnos select: [ : alumno | alumno legajo = numeroDeLegajo]) first.! !

!HomeAlumnos methodsFor: 'initializing' stamp: 'PabloAlegre 2/15/2013 01:01'!
initialize 

	alumnos:= OrderedCollection new.
	alumnos add: (Alumno conMateriasCursadas).
	alumnos add: (Alumno conNombre: 'Natalia' conApellido: 'Rodriguez' conDNI: 35111111 conDireccion: 'Quilmes' conEmail: 'nati@gmail.com'  yLegajo: 20111).
	alumnos add: (Alumno conNombre: 'Nahuel' conApellido: 'Garbezza' conDNI: 35222222 conDireccion: 'Ranelagh' conEmail: 'nahuel@gmail.com'  yLegajo: 20222).
	alumnos add: (Alumno conNombre: 'Ronny' conApellido: 'De Jesus' conDNI: 35333333 conDireccion: 'Berazategui' conEmail: 'ronny@gmail.com'  yLegajo: 20333).
	alumnos add: (Alumno conNombre: 'Susana' conApellido: 'Rosito' conDNI: 35444444 conDireccion: 'Berazategui' conEmail: 'susi@gmail.com'  yLegajo: 20444).
	alumnos add: (Alumno conNombre: 'Federico' conApellido: 'Sawady' conDNI: 35555555 conDireccion: 'Quilmes' conEmail: 'sawa@gmail.com'  yLegajo: 20555).
	alumnos add: (Alumno conNombre: 'Maria Laura' conApellido: 'Medici' conDNI: 35666666 conDireccion: 'Ezpeleta' conEmail: 'marilau@gmail.com'  yLegajo: 20666).
	alumnos add: (Alumno conNombre: 'Christian' conApellido: 'Ruiz Diaz' conDNI: 35777777 conDireccion: 'Berazategui' conEmail: 'christiand@gmail.com'  yLegajo: 20777).
	alumnos add: (Alumno conNombre: 'Rocio' conApellido: 'Amaya' conDNI: 35888888 conDireccion: 'Wilde' conEmail: 'rocio@gmail.com'  yLegajo: 20888).
	alumnos add: (Alumno conNombre: 'Tatiana' conApellido: 'Molinari' conDNI: 35999999 conDireccion: 'Lanus' conEmail: 'tatiana@gmail.com'  yLegajo: 20999).
	alumnos add: (Alumno conNombre: 'Cristian' conApellido: 'Suarez' conDNI: 36000000 conDireccion: 'Bernal' conEmail: 'cristian@gmail.com'  yLegajo: 21000).
	alumnos add: (Alumno conNombre: 'Cristian' conApellido: 'Bouix' conDNI: 36111111 conDireccion: 'Florencio Varela' conEmail: 'chbouix@gmail.com'  yLegajo: 21111).! !

!HomeAlumnos methodsFor: 'accessing' stamp: 'PabloAlegre 2/14/2013 00:01'!
listAll 

	^ self alumnos! !

Object subclass: #HomeCarreras
	instanceVariableNames: 'carreras'
	classVariableNames: 'instance'
	poolDictionaries: ''
	category: 'AdministradorUniversitario-Persistencia'!

!HomeCarreras class methodsFor: 'accessing' stamp: 'PabloAlegre 2/14/2013 00:24'!
current
	"instance:= nil."
	(instance isNil) ifTrue: [instance:= super new.].
	^instance.! !

!HomeCarreras methodsFor: 'accessing' stamp: 'PabloAlegre 2/14/2013 00:03'!
carreras
	^ carreras! !

!HomeCarreras methodsFor: 'accessing' stamp: 'PabloAlegre 2/14/2013 00:03'!
carreras: anObject
	carreras := anObject! !

!HomeCarreras methodsFor: 'accessing' stamp: 'PabloAlegre 2/14/2013 00:20'!
get: nombreDeCarrera

	^(self carreras select: [ : carrera | carrera nombre = nombreDeCarrera]) first.! !

!HomeCarreras methodsFor: 'initializing' stamp: 'PabloAlegre 2/14/2013 00:17'!
initialize

	| tpi lds |
	carreras:= OrderedCollection new.
	tpi:= (Carrera llamada: 'TPI').
	tpi materias add: (HomeMaterias current get: 'InPr').
	tpi materias add: (HomeMaterias current get: 'Mate1').
	tpi materias add: (HomeMaterias current get: 'Orga').
	tpi materias add: (HomeMaterias current get: 'Obj1').
	tpi materias add: (HomeMaterias current get: 'BD').
	tpi materias add: (HomeMaterias current get: 'SO').
	tpi materias add: (HomeMaterias current get: 'Obj2').
	tpi materias add: (HomeMaterias current get: 'Redes').
	tpi materias add: (HomeMaterias current get: 'LabSOR').
	tpi materias add: (HomeMaterias current get: 'CIU').
	tpi materias add: (HomeMaterias current get: 'IngSoft').
	tpi materias add: (HomeMaterias current get: 'Mate2').	
	tpi materias add: (HomeMaterias current get: 'DesApp').
	tpi materias do: [ :materia | materia carreras add: tpi].
	carreras add: tpi.
	lds:= (Carrera llamada: 'LDS').
	lds materias addAll: (tpi materias).
	lds materias add: (HomeMaterias current get: 'DerAut').	
	lds materias add: (HomeMaterias current get: 'Obj3').
	lds materias do: [ :materia | materia carreras add: lds].
	carreras add: lds.
	carreras add: (Carrera llamada: 'DPI').! !

!HomeCarreras methodsFor: 'accessing' stamp: 'PabloAlegre 2/14/2013 00:02'!
listAll 

	^ self carreras! !

Object subclass: #HomeComisiones
	instanceVariableNames: 'comisiones'
	classVariableNames: 'instance'
	poolDictionaries: ''
	category: 'AdministradorUniversitario-Persistencia'!

!HomeComisiones class methodsFor: 'accessing' stamp: 'PabloAlegre 2/14/2013 00:24'!
current
	"instance:= nil."
	(instance isNil) ifTrue: [instance:= super new.].
	^instance.! !

!HomeComisiones methodsFor: 'accessing' stamp: 'PabloAlegre 2/14/2013 00:03'!
comisiones
	^ comisiones! !

!HomeComisiones methodsFor: 'accessing' stamp: 'PabloAlegre 2/14/2013 00:03'!
comisiones: anObject
	comisiones := anObject! !

!HomeComisiones methodsFor: 'initializing' stamp: 'PabloAlegre 2/14/2013 00:19'!
initialize 

	| intro1 intro2 intro3 intro4 |
	comisiones:= OrderedCollection new.
	intro1:= Comision numero: 1 delCuatrimestre: '2008c1' deLaMateria: (HomeMaterias current get: 'InPr').
	intro2:= Comision numero: 2 delCuatrimestre: '2008c1' deLaMateria: (HomeMaterias current get: 'InPr').
	intro3:= Comision numero: 3 delCuatrimestre: '2008c1' deLaMateria: (HomeMaterias current get: 'InPr').
	intro4:= Comision numero: 4 delCuatrimestre: '2008c1' deLaMateria: (HomeMaterias current get: 'InPr').
	comisiones add: (intro1).
	comisiones add: (intro2).
	comisiones add: (intro3).
	comisiones add: (intro4).
	comisiones add: (Comision numero: 1 delCuatrimestre: '2008c1' deLaMateria: (HomeMaterias current get: 'Mate1')).
	comisiones add: (Comision numero: 2 delCuatrimestre: '2008c1' deLaMateria: (HomeMaterias current get: 'Mate1')).
	comisiones add: (Comision numero: 1 delCuatrimestre: '2008c1' deLaMateria: (HomeMaterias current get: 'Orga')).
	comisiones add: (Comision numero: 2 delCuatrimestre: '2008c1' deLaMateria: (HomeMaterias current get: 'Orga')).
	comisiones add: (Comision numero: 3 delCuatrimestre: '2008c1' deLaMateria: (HomeMaterias current get: 'Orga')).! !

!HomeComisiones methodsFor: 'accessing' stamp: 'PabloAlegre 2/14/2013 00:02'!
listAll

	^self comisiones  ! !

Object subclass: #HomeMaterias
	instanceVariableNames: 'materias'
	classVariableNames: 'instance'
	poolDictionaries: ''
	category: 'AdministradorUniversitario-Persistencia'!

!HomeMaterias class methodsFor: 'accessing' stamp: 'PabloAlegre 2/20/2013 22:50'!
current
	"instance:= nil."
	(instance isNil) ifTrue: [instance:= super new.].
	^instance.! !

!HomeMaterias methodsFor: 'accessing' stamp: 'PabloAlegre 2/14/2013 00:20'!
get: nombreDeMateria

	^(self materias select: [ : materia | materia nombre = nombreDeMateria]) first.! !

!HomeMaterias methodsFor: 'initializing' stamp: 'PabloAlegre 2/20/2013 22:41'!
initialize 

	| inpr |
	materias:= OrderedCollection new.
	inpr :=  (Materia deNombre: 'InPr').
	inpr comisiones add: (Comision numero: 1  delCuatrimestre: '2008-C1' deLaMateria: (inpr asString)).
	inpr comisiones add: (Comision numero: 2  delCuatrimestre: '2008-C1' deLaMateria: (inpr asString)).
	inpr comisiones add: (Comision numero: 3 delCuatrimestre: '2008-C1' deLaMateria: (inpr asString)).
	inpr comisiones add: (Comision numero: 4  delCuatrimestre: '2008-C1' deLaMateria: (inpr asString)).
	materias add: inpr.
	materias add: (Materia deNombre: 'Orga').
	materias add: (Materia deNombre: 'Mate1').
	materias add: (Materia deNombre: 'Obj1').
	materias add: (Materia deNombre: 'Mate2').
	materias add: (Materia deNombre: 'BD').
	materias add: (Materia deNombre: 'Obj2').
	materias add: (Materia deNombre: 'Redes').
	materias add: (Materia deNombre: 'SO').
	materias add: (Materia deNombre: 'LabSOR').
	materias add: (Materia deNombre: 'CIU').
	materias add: (Materia deNombre: 'IngSoft').
	materias add: (Materia deNombre: 'DesApp').
	materias add: (Materia deNombre: 'DerAut').
	materias add: (Materia deNombre: 'Obj3').! !

!HomeMaterias methodsFor: 'accessing' stamp: 'PabloAlegre 2/14/2013 00:03'!
listAll 

	^ self materias! !

!HomeMaterias methodsFor: 'accessing' stamp: 'PabloAlegre 2/14/2013 00:04'!
materias
	^ materias! !

!HomeMaterias methodsFor: 'accessing' stamp: 'PabloAlegre 2/14/2013 00:04'!
materias: anObject
	materias := anObject! !

Object subclass: #Materia
	instanceVariableNames: 'nombre carreras comisiones correlativas'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AdministradorUniversitario-Modelo'!

!Materia class methodsFor: 'class initialization' stamp: 'PabloAlegre 2/13/2013 22:41'!
deNombre: unNombre
	^ super new
		nombre: unNombre;
		carreras: OrderedCollection new;
		comisiones: OrderedCollection new;
		correlativas: OrderedCollection new! !

!Materia methodsFor: 'accessing' stamp: 'PabloAlegre 2/13/2013 22:05'!
carreras
	^ carreras! !

!Materia methodsFor: 'accessing' stamp: 'PabloAlegre 2/13/2013 22:05'!
carreras: anObject
	carreras := anObject! !

!Materia methodsFor: 'accessing' stamp: 'PabloAlegre 2/13/2013 22:05'!
comisiones
	^ comisiones! !

!Materia methodsFor: 'accessing' stamp: 'PabloAlegre 2/13/2013 22:05'!
comisiones: anObject
	comisiones := anObject! !

!Materia methodsFor: 'accessing' stamp: 'PabloAlegre 2/13/2013 22:05'!
correlativas
	^ correlativas! !

!Materia methodsFor: 'accessing' stamp: 'PabloAlegre 2/13/2013 22:05'!
correlativas: anObject
	correlativas := anObject! !

!Materia methodsFor: 'accessing' stamp: 'PabloAlegre 2/13/2013 22:05'!
nombre
	^ nombre! !

!Materia methodsFor: 'accessing' stamp: 'PabloAlegre 2/13/2013 22:05'!
nombre: anObject
	nombre := anObject! !

!Materia methodsFor: 'printing' stamp: 'PabloAlegre 2/13/2013 22:51'!
printOn: aStream

    aStream nextPutAll: (self nombre).! !

Materia subclass: #MateriaCursada
	instanceVariableNames: 'comision estado nota'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AdministradorUniversitario-Modelo'!

!MateriaCursada class methodsFor: 'class initialization' stamp: 'PabloAlegre 2/13/2013 22:59'!
enComision: unaComision
	^ super new initializeWith: unaComision.! !

!MateriaCursada methodsFor: 'accessing' stamp: 'PabloAlegre 2/13/2013 22:36'!
carreras
	^self comision materia carreras.! !

!MateriaCursada methodsFor: 'accessing' stamp: 'PabloAlegre 2/13/2013 22:54'!
comision
	^ comision! !

!MateriaCursada methodsFor: 'accessing' stamp: 'PabloAlegre 2/13/2013 22:54'!
comision: anObject
	comision := anObject! !

!MateriaCursada methodsFor: 'accessing' stamp: 'PabloAlegre 2/13/2013 22:36'!
comisiones
	^self comision materia comisiones.! !

!MateriaCursada methodsFor: 'as yet unclassified' stamp: 'PabloAlegre 2/20/2013 21:54'!
contieneCarrera: unaCarrera

	^self carreras includes: unaCarrera.! !

!MateriaCursada methodsFor: 'accessing' stamp: 'PabloAlegre 2/13/2013 22:36'!
correlativas
	^self comision materia correlativas.! !

!MateriaCursada methodsFor: 'accessing' stamp: 'PabloAlegre 2/15/2013 01:15'!
cuatrimestre

	^self comision cuatrimestre! !

!MateriaCursada methodsFor: 'accessing' stamp: 'PabloAlegre 2/13/2013 22:54'!
estado
	^ estado! !

!MateriaCursada methodsFor: 'accessing' stamp: 'PabloAlegre 2/13/2013 22:54'!
estado: anObject
	estado := anObject! !

!MateriaCursada methodsFor: 'initializing' stamp: 'PabloAlegre 2/13/2013 23:02'!
initializeWith: unaComision
	self
		comision: unaComision;
		nombre: unaComision materia nombre;
		correlativas: unaComision materia correlativas;
		comisiones: unaComision materia comisiones;
		carreras: unaComision materia carreras;
		estado: 'En curso';
		nota: 0! !

!MateriaCursada methodsFor: 'accessing' stamp: 'PabloAlegre 2/13/2013 22:36'!
nombre
	^self comision materia nombre.! !

!MateriaCursada methodsFor: 'accessing' stamp: 'PabloAlegre 2/13/2013 22:54'!
nota
	^ nota! !

!MateriaCursada methodsFor: 'accessing' stamp: 'PabloAlegre 2/13/2013 22:54'!
nota: anObject
	nota := anObject! !

!MateriaCursada methodsFor: 'as yet unclassified' stamp: 'PabloAlegre 2/18/2013 16:14'!
perteneceACarrera: unaCarrera

	| nombresDeCarreras |
	nombresDeCarreras := (self carreras collect: [ : carrera | carrera nombre ]) asSet. 
	^ nombresDeCarreras includes: unaCarrera nombre.! !

!MateriaCursada methodsFor: 'printing' stamp: 'PabloAlegre 2/13/2013 22:52'!
printOn: aStream

	   aStream nextPutAll: (self comision asString).! !
